SHEBANG
# Copyright @BABOLO (C)2002,2003 http://www.babolo.ru/
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $Id: addon-linker.m4,v 1.1 2008/12/15 00:47:01 babolo Exp $

JNTROSTUP(sshd,-linker,sshd,dnl
# jailup sshd-linker dir user [uid]
#     where dir relative to ${JAILUPDIR} and ${JAILRODIR}
#     uid = 65537 if not defined
dnl
)

jdir="${1}"
user="${2}"
group="${user}"
uid="${3:-65537}"
main_dir="${JAILUPDIR}/${jdir}"
conf_dir="${JAILRODIR}/${jdir}"

${mkdir} "${main_dir}" "${conf_dir}/home/${user}/.ssh"
${up_mdir} "${main_dir}" ${MTREE}
${up_conf} "${conf_dir}/home/${user}/.ssh/" ~${user}/.ssh/ << "EOF"
    authorized_keys
EOF
${up_shlib} "${main_dir}/lib" << "EOF"
    c
EOF

${up_libexe} "${main_dir}/libexec" << EOF
    ld-elf.so.1
    ${PREFIX}/libexec/jailup/sshd/stub
EOF

      #####################################
      ####                             ####
      #### Begin of etc fill           ####
      ####                             ####
${cat} << EOF >> "${conf_dir}/group"
${group}:*:${uid}:
EOF

${cat} << EOF >> "${conf_dir}/master.template"
${user}:*:${uid}:${uid}::0:0:User:/etc/home/${user}:/libexec/stub
EOF

if  [ ! -e "${conf_dir}/master.passwd" ]; then
    ${cp} -p "${conf_dir}/master.template" "${conf_dir}/master.passwd"
fi

      ####                             ####
      #### End of etc fill             ####
      ####                             ####
      #####################################

${mtree} -Ueqxp "${main_dir}" -f ${MTREE}
${mtree} -Ueqxp "${conf_dir}" << EOF
/set type=file uname=root gname=wheel mode=0644 flags=none
.				type=dir mode=0755
    group
    master.passwd		mode=0600
/set type=dir mode=0755
    home
/set uid=${uid}
        ${user}
            .ssh
                authorized_keys	type=file mode=0644
            ..
        ..
    ..
..
EOF
${pwd_mkdb} -d "${conf_dir}" -p "${conf_dir}/master.passwd"

      #####################################
      ####                             ####
      #### Begin of fstab mod          ####
      ####                             ####
${cat} << EOF >> "${etcdir}/fstab"
# !!! Replace this for that from sshd !!!
#devfs			${main_dir}/dev	devfs	rw		0 0
EOF

${cat} << EOF >> "${STARTUPDIR}/devfs"
# !!! Replace this for that from sshd !!!
${jdir}	null	sshd-linker
EOF
      ####                             ####
      #### End of fstab mod            ####
      ####                             ####
      #####################################
